/* A Bison parser, made by GNU Bison 3.7.6.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30706

/* Bison version string.  */
#define YYBISON_VERSION "3.7.6"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         parserparse
#define yylex           parserlex
#define yyerror         parsererror
#define yydebug         parserdebug
#define yynerrs         parsernerrs
#define yylval          parserlval
#define yychar          parserchar
#define yylloc          parserlloc

/* First part of user prologue.  */
#line 29 "src/parser.y"


#include <sys/types.h>
#include <sys/stat.h>
#ifdef _MSC_VER
#define strdup _strdup
#else
#include <unistd.h>
#endif

#include "FileModule.h"
#include "UserModule.h"
#include "ModuleInstantiation.h"
#include "Assignment.h"
#include "expression.h"
#include "value.h"
#include "function.h"
#include "printutils.h"
#include "memory.h"
#include <sstream>
#include <stack>
#include <boost/filesystem.hpp>
#include "boost-utils.h"
#include "feature.h"

namespace fs = boost::filesystem;

#define YYMAXDEPTH 20000
#define LOC(loc) Location(loc.first_line, loc.first_column, loc.last_line, loc.last_column, sourcefile())
#ifdef DEBUG
static Location debug_location(const std::string& info, const struct YYLTYPE& loc);
#define LOCD(str, loc) debug_location(str, loc)
#else
#define LOCD(str, loc) LOC(loc)
#endif

int parser_error_pos = -1;

int parserlex(void);
void yyerror(char const *s);

int lexerget_lineno(void);
bool lexer_is_main_file();
std::shared_ptr<fs::path> sourcefile(void);
void lexer_set_parser_sourcefile(const fs::path& path);
int lexerlex_destroy(void);
int lexerlex(void);
static void handle_assignment(const std::string token, Expression *expr, const Location loc);

std::stack<LocalScope *> scope_stack;
FileModule *rootmodule;

extern void lexerdestroy();
extern FILE *lexerin;
const char *parser_input_buffer;
static fs::path mainFilePath;
static bool parsingMainFile;
static std::string sourcefile_folder;

bool fileEnded=false;

#line 141 "objects/parser.cxx"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "parser.hxx"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_TOK_ERROR = 3,                  /* TOK_ERROR  */
  YYSYMBOL_TOK_EOT = 4,                    /* TOK_EOT  */
  YYSYMBOL_TOK_MODULE = 5,                 /* TOK_MODULE  */
  YYSYMBOL_TOK_FUNCTION = 6,               /* TOK_FUNCTION  */
  YYSYMBOL_TOK_IF = 7,                     /* TOK_IF  */
  YYSYMBOL_TOK_ELSE = 8,                   /* TOK_ELSE  */
  YYSYMBOL_TOK_FOR = 9,                    /* TOK_FOR  */
  YYSYMBOL_TOK_LET = 10,                   /* TOK_LET  */
  YYSYMBOL_TOK_ASSERT = 11,                /* TOK_ASSERT  */
  YYSYMBOL_TOK_ECHO = 12,                  /* TOK_ECHO  */
  YYSYMBOL_TOK_EACH = 13,                  /* TOK_EACH  */
  YYSYMBOL_TOK_ID = 14,                    /* TOK_ID  */
  YYSYMBOL_TOK_STRING = 15,                /* TOK_STRING  */
  YYSYMBOL_TOK_USE = 16,                   /* TOK_USE  */
  YYSYMBOL_TOK_NUMBER = 17,                /* TOK_NUMBER  */
  YYSYMBOL_TOK_TRUE = 18,                  /* TOK_TRUE  */
  YYSYMBOL_TOK_FALSE = 19,                 /* TOK_FALSE  */
  YYSYMBOL_TOK_UNDEF = 20,                 /* TOK_UNDEF  */
  YYSYMBOL_LE = 21,                        /* LE  */
  YYSYMBOL_GE = 22,                        /* GE  */
  YYSYMBOL_EQ = 23,                        /* EQ  */
  YYSYMBOL_NE = 24,                        /* NE  */
  YYSYMBOL_AND = 25,                       /* AND  */
  YYSYMBOL_OR = 26,                        /* OR  */
  YYSYMBOL_NO_ELSE = 27,                   /* NO_ELSE  */
  YYSYMBOL_28_ = 28,                       /* ';'  */
  YYSYMBOL_29_ = 29,                       /* '{'  */
  YYSYMBOL_30_ = 30,                       /* '}'  */
  YYSYMBOL_31_ = 31,                       /* '('  */
  YYSYMBOL_32_ = 32,                       /* ')'  */
  YYSYMBOL_33_ = 33,                       /* '='  */
  YYSYMBOL_34_ = 34,                       /* '!'  */
  YYSYMBOL_35_ = 35,                       /* '#'  */
  YYSYMBOL_36_ = 36,                       /* '%'  */
  YYSYMBOL_37_ = 37,                       /* '*'  */
  YYSYMBOL_38_ = 38,                       /* '?'  */
  YYSYMBOL_39_ = 39,                       /* ':'  */
  YYSYMBOL_40_ = 40,                       /* '>'  */
  YYSYMBOL_41_ = 41,                       /* '<'  */
  YYSYMBOL_42_ = 42,                       /* '+'  */
  YYSYMBOL_43_ = 43,                       /* '-'  */
  YYSYMBOL_44_ = 44,                       /* '/'  */
  YYSYMBOL_45_ = 45,                       /* '^'  */
  YYSYMBOL_46_ = 46,                       /* '['  */
  YYSYMBOL_47_ = 47,                       /* ']'  */
  YYSYMBOL_48_ = 48,                       /* '.'  */
  YYSYMBOL_49_ = 49,                       /* ','  */
  YYSYMBOL_YYACCEPT = 50,                  /* $accept  */
  YYSYMBOL_input = 51,                     /* input  */
  YYSYMBOL_statement = 52,                 /* statement  */
  YYSYMBOL_53_1 = 53,                      /* $@1  */
  YYSYMBOL_inner_input = 54,               /* inner_input  */
  YYSYMBOL_assignment = 55,                /* assignment  */
  YYSYMBOL_module_instantiation = 56,      /* module_instantiation  */
  YYSYMBOL_57_2 = 57,                      /* @2  */
  YYSYMBOL_ifelse_statement = 58,          /* ifelse_statement  */
  YYSYMBOL_59_3 = 59,                      /* $@3  */
  YYSYMBOL_if_statement = 60,              /* if_statement  */
  YYSYMBOL_61_4 = 61,                      /* @4  */
  YYSYMBOL_child_statements = 62,          /* child_statements  */
  YYSYMBOL_child_statement = 63,           /* child_statement  */
  YYSYMBOL_module_id = 64,                 /* module_id  */
  YYSYMBOL_single_module_instantiation = 65, /* single_module_instantiation  */
  YYSYMBOL_expr = 66,                      /* expr  */
  YYSYMBOL_logic_or = 67,                  /* logic_or  */
  YYSYMBOL_logic_and = 68,                 /* logic_and  */
  YYSYMBOL_equality = 69,                  /* equality  */
  YYSYMBOL_comparison = 70,                /* comparison  */
  YYSYMBOL_addition = 71,                  /* addition  */
  YYSYMBOL_multiplication = 72,            /* multiplication  */
  YYSYMBOL_unary = 73,                     /* unary  */
  YYSYMBOL_exponent = 74,                  /* exponent  */
  YYSYMBOL_call = 75,                      /* call  */
  YYSYMBOL_primary = 76,                   /* primary  */
  YYSYMBOL_expr_or_empty = 77,             /* expr_or_empty  */
  YYSYMBOL_list_comprehension_elements = 78, /* list_comprehension_elements  */
  YYSYMBOL_list_comprehension_elements_p = 79, /* list_comprehension_elements_p  */
  YYSYMBOL_list_comprehension_elements_or_expr = 80, /* list_comprehension_elements_or_expr  */
  YYSYMBOL_optional_commas = 81,           /* optional_commas  */
  YYSYMBOL_vector_expr = 82,               /* vector_expr  */
  YYSYMBOL_arguments_decl = 83,            /* arguments_decl  */
  YYSYMBOL_argument_decl = 84,             /* argument_decl  */
  YYSYMBOL_arguments_call = 85,            /* arguments_call  */
  YYSYMBOL_argument_call = 86              /* argument_call  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_uint8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   412

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  50
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  37
/* YYNRULES -- Number of rules.  */
#define YYNRULES  113
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  226

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   282


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    34,     2,    35,     2,    36,     2,     2,
      31,    32,    37,    42,    49,    43,    48,    44,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    39,    28,
      41,    33,    40,    38,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    46,     2,    47,    45,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    29,     2,    30,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   174,   174,   175,   181,   185,   186,   187,   191,   193,
     192,   206,   214,   221,   222,   226,   234,   239,   244,   249,
     255,   254,   264,   271,   276,   275,   288,   287,   300,   301,
     302,   306,   307,   308,   316,   317,   318,   319,   320,   321,
     325,   334,   335,   340,   344,   349,   354,   362,   363,   370,
     371,   378,   379,   383,   390,   391,   395,   399,   403,   410,
     411,   415,   422,   423,   427,   431,   439,   440,   444,   448,
     455,   456,   463,   464,   469,   473,   481,   485,   489,   493,
     497,   502,   507,   511,   515,   519,   523,   531,   534,   543,
     548,   552,   565,   571,   575,   583,   584,   591,   592,   596,
     597,   601,   606,   611,   620,   623,   628,   636,   641,   650,
     653,   658,   666,   670
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "TOK_ERROR", "TOK_EOT",
  "TOK_MODULE", "TOK_FUNCTION", "TOK_IF", "TOK_ELSE", "TOK_FOR", "TOK_LET",
  "TOK_ASSERT", "TOK_ECHO", "TOK_EACH", "TOK_ID", "TOK_STRING", "TOK_USE",
  "TOK_NUMBER", "TOK_TRUE", "TOK_FALSE", "TOK_UNDEF", "LE", "GE", "EQ",
  "NE", "AND", "OR", "NO_ELSE", "';'", "'{'", "'}'", "'('", "')'", "'='",
  "'!'", "'#'", "'%'", "'*'", "'?'", "':'", "'>'", "'<'", "'+'", "'-'",
  "'/'", "'^'", "'['", "']'", "'.'", "','", "$accept", "input",
  "statement", "$@1", "inner_input", "assignment", "module_instantiation",
  "@2", "ifelse_statement", "$@3", "if_statement", "@4",
  "child_statements", "child_statement", "module_id",
  "single_module_instantiation", "expr", "logic_or", "logic_and",
  "equality", "comparison", "addition", "multiplication", "unary",
  "exponent", "call", "primary", "expr_or_empty",
  "list_comprehension_elements", "list_comprehension_elements_p",
  "list_comprehension_elements_or_expr", "optional_commas", "vector_expr",
  "arguments_decl", "argument_decl", "arguments_call", "argument_call", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,    59,   123,
     125,    40,    41,    61,    33,    35,    37,    42,    63,    58,
      62,    60,    43,    45,    47,    94,    91,    93,    46,    44
};
#endif

#define YYPACT_NINF (-154)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-1)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -154,   312,  -154,  -154,    13,    27,    26,  -154,  -154,  -154,
    -154,  -154,    14,  -154,  -154,   325,   256,   256,   256,   256,
    -154,  -154,  -154,  -154,    54,    52,  -154,    55,    62,   230,
     230,   325,    59,  -154,  -154,  -154,  -154,  -154,  -154,   268,
     365,    83,    83,    68,    69,    74,    75,  -154,  -154,  -154,
    -154,  -154,  -154,   230,   349,   349,   349,   112,    76,    16,
      84,    58,     4,   -22,    41,  -154,  -154,    -8,  -154,    85,
    -154,  -154,   365,    78,  -154,   -13,  -154,  -154,  -154,  -154,
    -154,    79,    65,  -154,    65,    83,   268,   268,   268,    88,
    -154,  -154,  -154,    97,   102,   103,   174,    66,    96,  -154,
      89,    90,  -154,   349,   230,   349,   349,   349,   349,   349,
     349,   349,   349,   349,   349,   349,   349,   268,   349,   230,
     123,  -154,  -154,   230,  -154,    66,   375,   230,    66,   109,
     110,    65,    -3,     0,    11,  -154,   230,   268,   268,   212,
    -154,  -154,  -154,  -154,  -154,   230,  -154,    66,    98,   365,
      84,   105,    58,     4,     4,   -22,   -22,   -22,   -22,    41,
      41,  -154,  -154,  -154,    19,  -154,   100,  -154,  -154,   268,
    -154,  -154,  -154,  -154,    83,  -154,   115,   120,   230,   230,
     230,   121,   -10,    20,   124,    40,   174,  -154,  -154,   230,
    -154,  -154,  -154,  -154,   325,   230,   230,  -154,  -154,  -154,
    -154,   174,   230,   174,   174,  -154,   230,  -154,  -154,  -154,
    -154,   131,  -154,   154,   135,  -154,  -154,   117,  -154,   174,
     268,  -154,  -154,    21,   174,  -154
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       2,     0,     1,    12,     0,     0,     0,    35,    36,    37,
      38,    39,    34,     3,     5,    13,     0,     0,     0,     0,
       4,     8,     7,    22,    23,     0,    20,     0,     0,     0,
       0,    13,     0,    34,    16,    17,    18,    19,    24,   109,
       0,   104,   104,     0,     0,     0,     0,    81,    80,    79,
      76,    77,    78,     0,     0,     0,     0,    99,     0,    41,
      47,    49,    51,    54,    59,    62,    66,    70,    72,     0,
      14,     6,     0,    81,   112,     0,   110,    31,    28,    33,
      21,   107,    99,   105,    99,   104,   109,   109,   109,     0,
      69,    67,    68,     0,     0,     0,     0,    99,   101,   102,
       0,    99,    26,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   109,     0,     0,
       0,    15,    25,     0,    40,    99,     0,     0,    99,     0,
       0,    99,     0,     0,     0,    82,     0,   109,   109,     0,
      98,    95,    97,    90,   100,     0,    85,    99,     0,     0,
      48,     0,    50,    52,    53,    58,    56,    55,    57,    60,
      61,    65,    63,    64,     0,    71,     0,    75,   113,     0,
      32,    30,    29,   108,   100,     9,     0,     0,     0,    87,
      87,     0,     0,     0,     0,     0,   100,    86,    27,     0,
      73,    74,   111,   106,     0,     0,     0,    44,    88,    45,
      46,     0,     0,     0,     0,    96,     0,    83,   103,    43,
      10,     0,    42,    93,     0,    91,    89,     0,    11,     0,
     109,    84,    94,     0,     0,    92
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -154,  -154,     2,  -154,   134,    42,    -9,  -154,  -154,  -154,
    -154,  -154,  -154,   -61,  -154,  -154,   -29,  -154,    67,    64,
     -15,    -7,   -17,   -42,  -154,  -154,  -154,    -4,   -55,   -33,
    -153,   -67,  -154,   -26,     5,   -82,     9
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_uint8 yydefgoto[] =
{
       0,     1,    31,   194,    32,    21,    22,    40,    23,    72,
      24,   149,   126,    80,    25,    26,    74,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,   199,   141,   142,
     143,   100,   101,    82,    83,    75,    76
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_uint8 yytable[] =
{
      58,    69,    99,    20,   132,   133,   134,    34,    35,    36,
      37,   122,    90,    91,    92,   129,    84,   130,   202,   124,
     112,   113,   203,   117,    89,   108,   109,    27,    98,   178,
     144,    79,   179,   208,   148,   164,   125,   118,   119,   125,
     120,    28,   103,   180,   110,   111,   125,    30,   213,   125,
     215,   190,   204,   224,   104,   182,   183,    29,   169,   131,
     125,   174,    38,    79,   177,   172,   222,   140,   125,   125,
     125,   225,   161,   162,   163,   151,   165,   114,   115,   206,
     186,   106,   107,    39,   184,   116,    41,   207,   188,    71,
     166,   153,   154,    42,   168,   159,   160,    81,   173,    85,
      86,   155,   156,   157,   158,    87,    88,   181,   102,   105,
      89,   123,   127,   121,   128,    97,   185,    79,    43,    93,
     135,    94,    95,    45,    46,    96,    47,    48,   136,    49,
      50,    51,    52,   137,   138,   145,   146,   167,   223,   147,
      79,   175,   176,    53,   189,   187,    54,   191,   195,   197,
     198,   198,   196,   201,    55,    56,   205,   140,    57,   218,
     209,    97,   219,   220,   221,    70,   211,   212,   171,   152,
     150,   216,   140,   214,   140,   197,   200,   217,   192,   193,
      43,    93,     0,    94,    95,    45,    46,    96,    47,    48,
     140,    49,    50,    51,    52,   140,   210,     0,     0,     0,
       0,     0,     0,     0,     0,   139,     0,     0,    54,     0,
       0,     0,     0,     0,     0,     0,    55,    56,    43,    93,
      57,    94,    95,    45,    46,    96,    47,    48,     0,    49,
      50,    51,    52,     0,     0,     0,    43,     0,     0,     0,
      44,    45,    46,    53,    47,    48,    54,    49,    50,    51,
      52,     0,     0,     0,    55,    56,     0,     0,    57,     0,
       0,    53,     0,     6,    54,     7,     8,     9,    10,    11,
      33,     0,    55,    56,    43,     0,    57,     0,    44,    45,
      46,     0,    73,    48,     0,    49,    50,    51,    52,     0,
      16,    17,    18,    19,     0,     0,     0,     0,     0,    53,
       0,     0,    54,     0,     0,     0,     0,     0,     0,     0,
      55,    56,     2,     0,    57,     0,     3,     4,     5,     6,
       0,     7,     8,     9,    10,    11,    12,     0,    13,     3,
       4,     5,     6,     0,     7,     8,     9,    10,    11,    12,
      14,    15,     0,     0,     0,     0,    16,    17,    18,    19,
       0,     0,     0,    14,    15,     0,     0,     0,     0,    16,
      17,    18,    19,    47,    48,     0,    49,    50,    51,    52,
       0,     0,     6,     0,     7,     8,     9,    10,    11,    33,
      53,     0,     6,    54,     7,     8,     9,    10,    11,    12,
       0,    55,    56,    77,    78,    57,     0,     0,     0,    16,
      17,    18,    19,    77,    78,   170,     0,     0,     0,    16,
      17,    18,    19
};

static const yytype_int16 yycheck[] =
{
      29,    30,    57,     1,    86,    87,    88,    16,    17,    18,
      19,    72,    54,    55,    56,    82,    42,    84,    28,    32,
      42,    43,    32,    31,    53,    21,    22,    14,    57,    32,
      97,    40,    32,   186,   101,   117,    49,    45,    46,    49,
      48,    14,    26,    32,    40,    41,    49,    33,   201,    49,
     203,    32,    32,    32,    38,   137,   138,    31,   125,    85,
      49,   128,     8,    72,   131,   126,   219,    96,    49,    49,
      49,   224,   114,   115,   116,   104,   118,    36,    37,    39,
     147,    23,    24,    31,   139,    44,    31,    47,   149,    30,
     119,   106,   107,    31,   123,   112,   113,    14,   127,    31,
      31,   108,   109,   110,   111,    31,    31,   136,    32,    25,
     139,    33,    33,    28,    49,    49,   145,   126,     6,     7,
      32,     9,    10,    11,    12,    13,    14,    15,    31,    17,
      18,    19,    20,    31,    31,    39,    47,    14,   220,    49,
     149,    32,    32,    31,    39,    47,    34,    47,    33,   178,
     179,   180,    32,    32,    42,    43,    32,   186,    46,    28,
     189,    49,     8,    28,    47,    31,   195,   196,   126,   105,
     103,   204,   201,   202,   203,   204,   180,   206,   169,   174,
       6,     7,    -1,     9,    10,    11,    12,    13,    14,    15,
     219,    17,    18,    19,    20,   224,   194,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    31,    -1,    -1,    34,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    42,    43,     6,     7,
      46,     9,    10,    11,    12,    13,    14,    15,    -1,    17,
      18,    19,    20,    -1,    -1,    -1,     6,    -1,    -1,    -1,
      10,    11,    12,    31,    14,    15,    34,    17,    18,    19,
      20,    -1,    -1,    -1,    42,    43,    -1,    -1,    46,    -1,
      -1,    31,    -1,     7,    34,     9,    10,    11,    12,    13,
      14,    -1,    42,    43,     6,    -1,    46,    -1,    10,    11,
      12,    -1,    14,    15,    -1,    17,    18,    19,    20,    -1,
      34,    35,    36,    37,    -1,    -1,    -1,    -1,    -1,    31,
      -1,    -1,    34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      42,    43,     0,    -1,    46,    -1,     4,     5,     6,     7,
      -1,     9,    10,    11,    12,    13,    14,    -1,    16,     4,
       5,     6,     7,    -1,     9,    10,    11,    12,    13,    14,
      28,    29,    -1,    -1,    -1,    -1,    34,    35,    36,    37,
      -1,    -1,    -1,    28,    29,    -1,    -1,    -1,    -1,    34,
      35,    36,    37,    14,    15,    -1,    17,    18,    19,    20,
      -1,    -1,     7,    -1,     9,    10,    11,    12,    13,    14,
      31,    -1,     7,    34,     9,    10,    11,    12,    13,    14,
      -1,    42,    43,    28,    29,    46,    -1,    -1,    -1,    34,
      35,    36,    37,    28,    29,    30,    -1,    -1,    -1,    34,
      35,    36,    37
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,    51,     0,     4,     5,     6,     7,     9,    10,    11,
      12,    13,    14,    16,    28,    29,    34,    35,    36,    37,
      52,    55,    56,    58,    60,    64,    65,    14,    14,    31,
      33,    52,    54,    14,    56,    56,    56,    56,     8,    31,
      57,    31,    31,     6,    10,    11,    12,    14,    15,    17,
      18,    19,    20,    31,    34,    42,    43,    46,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    66,
      54,    30,    59,    14,    66,    85,    86,    28,    29,    56,
      63,    14,    83,    84,    83,    31,    31,    31,    31,    66,
      73,    73,    73,     7,     9,    10,    13,    49,    66,    78,
      81,    82,    32,    26,    38,    25,    23,    24,    21,    22,
      40,    41,    42,    43,    36,    37,    44,    31,    45,    46,
      48,    28,    63,    33,    32,    49,    62,    33,    49,    81,
      81,    83,    85,    85,    85,    32,    31,    31,    31,    31,
      66,    78,    79,    80,    81,    39,    47,    49,    81,    61,
      68,    66,    69,    70,    70,    71,    71,    71,    71,    72,
      72,    73,    73,    73,    85,    73,    66,    14,    66,    81,
      30,    55,    63,    66,    81,    32,    32,    81,    32,    32,
      32,    66,    85,    85,    78,    66,    81,    47,    63,    39,
      32,    47,    86,    84,    53,    33,    32,    66,    66,    77,
      77,    32,    28,    32,    32,    32,    39,    47,    80,    66,
      52,    66,    66,    80,    66,    80,    79,    66,    28,     8,
      28,    47,    80,    85,    32,    80
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int8 yyr1[] =
{
       0,    50,    51,    51,    51,    52,    52,    52,    52,    53,
      52,    52,    52,    54,    54,    55,    56,    56,    56,    56,
      57,    56,    56,    58,    59,    58,    61,    60,    62,    62,
      62,    63,    63,    63,    64,    64,    64,    64,    64,    64,
      65,    66,    66,    66,    66,    66,    66,    67,    67,    68,
      68,    69,    69,    69,    70,    70,    70,    70,    70,    71,
      71,    71,    72,    72,    72,    72,    73,    73,    73,    73,
      74,    74,    75,    75,    75,    75,    76,    76,    76,    76,
      76,    76,    76,    76,    76,    76,    76,    77,    77,    78,
      78,    78,    78,    78,    78,    79,    79,    80,    80,    81,
      81,    82,    82,    82,    83,    83,    83,    84,    84,    85,
      85,    85,    86,    86
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     2,     2,     1,     3,     1,     1,     0,
       8,     9,     1,     0,     2,     4,     2,     2,     2,     2,
       0,     3,     1,     1,     0,     4,     0,     6,     0,     2,
       2,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       4,     1,     6,     5,     5,     5,     5,     1,     3,     1,
       3,     1,     3,     3,     1,     3,     3,     3,     3,     1,
       3,     3,     1,     3,     3,     3,     1,     2,     2,     2,
       1,     3,     1,     4,     4,     3,     1,     1,     1,     1,
       1,     1,     3,     5,     7,     3,     4,     0,     1,     5,
       2,     5,     9,     5,     7,     1,     3,     1,     1,     0,
       2,     1,     1,     4,     0,     1,     4,     1,     3,     0,
       1,     4,     1,     3
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YY_LOCATION_PRINT
#  if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#   define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

#  else
#   define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#  endif
# endif /* !defined YY_LOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (yylocationp);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YY_LOCATION_PRINT (yyo, *yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]));
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YY_USE (yyvaluep);
  YY_USE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

/* User initialization code.  */
#line 92 "src/parser.y"
{
  yylloc.first_line = 1;
  yylloc.first_column = 1;
  yylloc.last_column = 1;
  yylloc.last_line = 1;
}

#line 1313 "objects/parser.cxx"

  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 3: /* input: input TOK_USE  */
#line 177 "src/parser.y"
            {
              rootmodule->registerUse(std::string((yyvsp[0].text)), lexer_is_main_file() && parsingMainFile ? LOC((yylsp[0])) : Location::NONE);
              free((yyvsp[0].text));
            }
#line 1528 "objects/parser.cxx"
    break;

  case 7: /* statement: module_instantiation  */
#line 188 "src/parser.y"
            {
              if ((yyvsp[0].inst)) scope_stack.top()->addChild(shared_ptr<ModuleInstantiation>((yyvsp[0].inst)));
            }
#line 1536 "objects/parser.cxx"
    break;

  case 9: /* $@1: %empty  */
#line 193 "src/parser.y"
            {
              UserModule *newmodule = new UserModule((yyvsp[-4].text), LOCD("module", (yyloc)));
              newmodule->definition_arguments = *(yyvsp[-2].args);
              auto top = scope_stack.top();
              scope_stack.push(&newmodule->scope);
              top->addChild(shared_ptr<UserModule>(newmodule));
              free((yyvsp[-4].text));
              delete (yyvsp[-2].args);
            }
#line 1550 "objects/parser.cxx"
    break;

  case 10: /* statement: TOK_MODULE TOK_ID '(' arguments_decl optional_commas ')' $@1 statement  */
#line 203 "src/parser.y"
            {
                scope_stack.pop();
            }
#line 1558 "objects/parser.cxx"
    break;

  case 11: /* statement: TOK_FUNCTION TOK_ID '(' arguments_decl optional_commas ')' '=' expr ';'  */
#line 207 "src/parser.y"
            {
              scope_stack.top()->addChild(
                make_shared<UserFunction>((yyvsp[-7].text), *(yyvsp[-5].args), shared_ptr<Expression>((yyvsp[-1].expr)), LOCD("function", (yyloc)))
              );
              free((yyvsp[-7].text));
              delete (yyvsp[-5].args);
            }
#line 1570 "objects/parser.cxx"
    break;

  case 12: /* statement: TOK_EOT  */
#line 215 "src/parser.y"
            {
                fileEnded=true;
            }
#line 1578 "objects/parser.cxx"
    break;

  case 15: /* assignment: TOK_ID '=' expr ';'  */
#line 227 "src/parser.y"
            {
                handle_assignment((yyvsp[-3].text), (yyvsp[-1].expr), LOCD("assignment", (yyloc)));
                free((yyvsp[-3].text));
            }
#line 1587 "objects/parser.cxx"
    break;

  case 16: /* module_instantiation: '!' module_instantiation  */
#line 235 "src/parser.y"
            {
                (yyval.inst) = (yyvsp[0].inst);
                if ((yyval.inst)) (yyval.inst)->tag_root = true;
            }
#line 1596 "objects/parser.cxx"
    break;

  case 17: /* module_instantiation: '#' module_instantiation  */
#line 240 "src/parser.y"
            {
                (yyval.inst) = (yyvsp[0].inst);
                if ((yyval.inst)) (yyval.inst)->tag_highlight = true;
            }
#line 1605 "objects/parser.cxx"
    break;

  case 18: /* module_instantiation: '%' module_instantiation  */
#line 245 "src/parser.y"
            {
                (yyval.inst) = (yyvsp[0].inst);
                if ((yyval.inst)) (yyval.inst)->tag_background = true;
            }
#line 1614 "objects/parser.cxx"
    break;

  case 19: /* module_instantiation: '*' module_instantiation  */
#line 250 "src/parser.y"
            {
                delete (yyvsp[0].inst);
                (yyval.inst) = NULL;
            }
#line 1623 "objects/parser.cxx"
    break;

  case 20: /* @2: %empty  */
#line 255 "src/parser.y"
            {
                (yyval.inst) = (yyvsp[0].inst);
                scope_stack.push(&(yyvsp[0].inst)->scope);
            }
#line 1632 "objects/parser.cxx"
    break;

  case 21: /* module_instantiation: single_module_instantiation @2 child_statement  */
#line 260 "src/parser.y"
            {
                scope_stack.pop();
                (yyval.inst) = (yyvsp[-1].inst);
            }
#line 1641 "objects/parser.cxx"
    break;

  case 22: /* module_instantiation: ifelse_statement  */
#line 265 "src/parser.y"
            {
                (yyval.inst) = (yyvsp[0].ifelse);
            }
#line 1649 "objects/parser.cxx"
    break;

  case 23: /* ifelse_statement: if_statement  */
#line 272 "src/parser.y"
            {
                (yyval.ifelse) = (yyvsp[0].ifelse);
            }
#line 1657 "objects/parser.cxx"
    break;

  case 24: /* $@3: %empty  */
#line 276 "src/parser.y"
            {
                scope_stack.push((yyvsp[-1].ifelse)->makeElseScope());
            }
#line 1665 "objects/parser.cxx"
    break;

  case 25: /* ifelse_statement: if_statement TOK_ELSE $@3 child_statement  */
#line 280 "src/parser.y"
            {
                scope_stack.pop();
                (yyval.ifelse) = (yyvsp[-3].ifelse);
            }
#line 1674 "objects/parser.cxx"
    break;

  case 26: /* @4: %empty  */
#line 288 "src/parser.y"
            {
                (yyval.ifelse) = new IfElseModuleInstantiation(shared_ptr<Expression>((yyvsp[-1].expr)), sourcefile_folder, LOCD("if", (yyloc)));
                scope_stack.push(&(yyval.ifelse)->scope);
            }
#line 1683 "objects/parser.cxx"
    break;

  case 27: /* if_statement: TOK_IF '(' expr ')' @4 child_statement  */
#line 293 "src/parser.y"
            {
                scope_stack.pop();
                (yyval.ifelse) = (yyvsp[-1].ifelse);
            }
#line 1692 "objects/parser.cxx"
    break;

  case 33: /* child_statement: module_instantiation  */
#line 309 "src/parser.y"
            {
                if ((yyvsp[0].inst)) scope_stack.top()->addChild(shared_ptr<ModuleInstantiation>((yyvsp[0].inst)));
            }
#line 1700 "objects/parser.cxx"
    break;

  case 34: /* module_id: TOK_ID  */
#line 316 "src/parser.y"
                  { (yyval.text) = (yyvsp[0].text); }
#line 1706 "objects/parser.cxx"
    break;

  case 35: /* module_id: TOK_FOR  */
#line 317 "src/parser.y"
                  { (yyval.text) = strdup("for"); }
#line 1712 "objects/parser.cxx"
    break;

  case 36: /* module_id: TOK_LET  */
#line 318 "src/parser.y"
                  { (yyval.text) = strdup("let"); }
#line 1718 "objects/parser.cxx"
    break;

  case 37: /* module_id: TOK_ASSERT  */
#line 319 "src/parser.y"
                     { (yyval.text) = strdup("assert"); }
#line 1724 "objects/parser.cxx"
    break;

  case 38: /* module_id: TOK_ECHO  */
#line 320 "src/parser.y"
                   { (yyval.text) = strdup("echo"); }
#line 1730 "objects/parser.cxx"
    break;

  case 39: /* module_id: TOK_EACH  */
#line 321 "src/parser.y"
                   { (yyval.text) = strdup("each"); }
#line 1736 "objects/parser.cxx"
    break;

  case 40: /* single_module_instantiation: module_id '(' arguments_call ')'  */
#line 326 "src/parser.y"
            {
                (yyval.inst) = new ModuleInstantiation((yyvsp[-3].text), *(yyvsp[-1].args), sourcefile_folder, LOCD("modulecall", (yyloc)));
                free((yyvsp[-3].text));
                delete (yyvsp[-1].args);
            }
#line 1746 "objects/parser.cxx"
    break;

  case 42: /* expr: TOK_FUNCTION '(' arguments_decl optional_commas ')' expr  */
#line 336 "src/parser.y"
            {
              (yyval.expr) = new FunctionDefinition((yyvsp[0].expr), *(yyvsp[-3].args), LOCD("anonfunc", (yyloc)));
              delete (yyvsp[-3].args);
            }
#line 1755 "objects/parser.cxx"
    break;

  case 43: /* expr: logic_or '?' expr ':' expr  */
#line 341 "src/parser.y"
            {
              (yyval.expr) = new TernaryOp((yyvsp[-4].expr), (yyvsp[-2].expr), (yyvsp[0].expr), LOCD("ternary", (yyloc)));
            }
#line 1763 "objects/parser.cxx"
    break;

  case 44: /* expr: TOK_LET '(' arguments_call ')' expr  */
#line 345 "src/parser.y"
            {
              (yyval.expr) = FunctionCall::create("let", *(yyvsp[-2].args), (yyvsp[0].expr), LOCD("let", (yyloc)));
              delete (yyvsp[-2].args);
            }
#line 1772 "objects/parser.cxx"
    break;

  case 45: /* expr: TOK_ASSERT '(' arguments_call ')' expr_or_empty  */
#line 350 "src/parser.y"
            {
              (yyval.expr) = FunctionCall::create("assert", *(yyvsp[-2].args), (yyvsp[0].expr), LOCD("assert", (yyloc)));
              delete (yyvsp[-2].args);
            }
#line 1781 "objects/parser.cxx"
    break;

  case 46: /* expr: TOK_ECHO '(' arguments_call ')' expr_or_empty  */
#line 355 "src/parser.y"
            {
              (yyval.expr) = FunctionCall::create("echo", *(yyvsp[-2].args), (yyvsp[0].expr), LOCD("echo", (yyloc)));
              delete (yyvsp[-2].args);
            }
#line 1790 "objects/parser.cxx"
    break;

  case 48: /* logic_or: logic_or OR logic_and  */
#line 364 "src/parser.y"
            {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::LogicalOr, (yyvsp[0].expr), LOCD("or", (yyloc)));
            }
#line 1798 "objects/parser.cxx"
    break;

  case 50: /* logic_and: logic_and AND equality  */
#line 372 "src/parser.y"
            {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::LogicalAnd, (yyvsp[0].expr), LOCD("and", (yyloc)));
            }
#line 1806 "objects/parser.cxx"
    break;

  case 52: /* equality: equality EQ comparison  */
#line 380 "src/parser.y"
            {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::Equal, (yyvsp[0].expr), LOCD("equal", (yyloc)));
            }
#line 1814 "objects/parser.cxx"
    break;

  case 53: /* equality: equality NE comparison  */
#line 384 "src/parser.y"
            {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::NotEqual, (yyvsp[0].expr), LOCD("notequal", (yyloc)));
            }
#line 1822 "objects/parser.cxx"
    break;

  case 55: /* comparison: comparison '>' addition  */
#line 392 "src/parser.y"
            {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::Greater, (yyvsp[0].expr), LOCD("greater", (yyloc)));
            }
#line 1830 "objects/parser.cxx"
    break;

  case 56: /* comparison: comparison GE addition  */
#line 396 "src/parser.y"
            {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::GreaterEqual, (yyvsp[0].expr), LOCD("greaterequal", (yyloc)));
            }
#line 1838 "objects/parser.cxx"
    break;

  case 57: /* comparison: comparison '<' addition  */
#line 400 "src/parser.y"
            {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::Less, (yyvsp[0].expr), LOCD("less", (yyloc)));
            }
#line 1846 "objects/parser.cxx"
    break;

  case 58: /* comparison: comparison LE addition  */
#line 404 "src/parser.y"
            {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::LessEqual, (yyvsp[0].expr), LOCD("lessequal", (yyloc)));
            }
#line 1854 "objects/parser.cxx"
    break;

  case 60: /* addition: addition '+' multiplication  */
#line 412 "src/parser.y"
            {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::Plus, (yyvsp[0].expr), LOCD("addition", (yyloc)));
            }
#line 1862 "objects/parser.cxx"
    break;

  case 61: /* addition: addition '-' multiplication  */
#line 416 "src/parser.y"
            {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::Minus, (yyvsp[0].expr), LOCD("subtraction", (yyloc)));
            }
#line 1870 "objects/parser.cxx"
    break;

  case 63: /* multiplication: multiplication '*' unary  */
#line 424 "src/parser.y"
            {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::Multiply, (yyvsp[0].expr), LOCD("multiply", (yyloc)));
            }
#line 1878 "objects/parser.cxx"
    break;

  case 64: /* multiplication: multiplication '/' unary  */
#line 428 "src/parser.y"
            {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::Divide, (yyvsp[0].expr), LOCD("divide", (yyloc)));
            }
#line 1886 "objects/parser.cxx"
    break;

  case 65: /* multiplication: multiplication '%' unary  */
#line 432 "src/parser.y"
            {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::Modulo, (yyvsp[0].expr), LOCD("modulo", (yyloc)));
            }
#line 1894 "objects/parser.cxx"
    break;

  case 67: /* unary: '+' unary  */
#line 441 "src/parser.y"
            {
                (yyval.expr) = (yyvsp[0].expr);
            }
#line 1902 "objects/parser.cxx"
    break;

  case 68: /* unary: '-' unary  */
#line 445 "src/parser.y"
            {
              (yyval.expr) = new UnaryOp(UnaryOp::Op::Negate, (yyvsp[0].expr), LOCD("negate", (yyloc)));
            }
#line 1910 "objects/parser.cxx"
    break;

  case 69: /* unary: '!' unary  */
#line 449 "src/parser.y"
            {
              (yyval.expr) = new UnaryOp(UnaryOp::Op::Not, (yyvsp[0].expr), LOCD("not", (yyloc)));
            }
#line 1918 "objects/parser.cxx"
    break;

  case 71: /* exponent: call '^' unary  */
#line 457 "src/parser.y"
           {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::Exponent, (yyvsp[0].expr), LOCD("exponent", (yyloc)));
           }
#line 1926 "objects/parser.cxx"
    break;

  case 73: /* call: call '(' arguments_call ')'  */
#line 465 "src/parser.y"
            {
              (yyval.expr) = new FunctionCall((yyvsp[-3].expr), *(yyvsp[-1].args), LOCD("functioncall", (yyloc)));
              delete (yyvsp[-1].args);
            }
#line 1935 "objects/parser.cxx"
    break;

  case 74: /* call: call '[' expr ']'  */
#line 470 "src/parser.y"
            {
              (yyval.expr) = new ArrayLookup((yyvsp[-3].expr), (yyvsp[-1].expr), LOCD("index", (yyloc)));
            }
#line 1943 "objects/parser.cxx"
    break;

  case 75: /* call: call '.' TOK_ID  */
#line 474 "src/parser.y"
            {
              (yyval.expr) = new MemberLookup((yyvsp[-2].expr), (yyvsp[0].text), LOCD("member", (yyloc)));
              free((yyvsp[0].text));
            }
#line 1952 "objects/parser.cxx"
    break;

  case 76: /* primary: TOK_TRUE  */
#line 482 "src/parser.y"
            {
              (yyval.expr) = new Literal(true, LOCD("literal", (yyloc)));
            }
#line 1960 "objects/parser.cxx"
    break;

  case 77: /* primary: TOK_FALSE  */
#line 486 "src/parser.y"
            {
              (yyval.expr) = new Literal(false, LOCD("literal", (yyloc)));
            }
#line 1968 "objects/parser.cxx"
    break;

  case 78: /* primary: TOK_UNDEF  */
#line 490 "src/parser.y"
            {
              (yyval.expr) = new Literal(Value::undefined.clone(), LOCD("literal", (yyloc)));
            }
#line 1976 "objects/parser.cxx"
    break;

  case 79: /* primary: TOK_NUMBER  */
#line 494 "src/parser.y"
            {
              (yyval.expr) = new Literal(Value((yyvsp[0].number)), LOCD("literal", (yyloc)));
            }
#line 1984 "objects/parser.cxx"
    break;

  case 80: /* primary: TOK_STRING  */
#line 498 "src/parser.y"
            {
              (yyval.expr) = new Literal(Value(std::string((yyvsp[0].text))), LOCD("string", (yyloc)));
              free((yyvsp[0].text));
            }
#line 1993 "objects/parser.cxx"
    break;

  case 81: /* primary: TOK_ID  */
#line 503 "src/parser.y"
            {
              (yyval.expr) = new Lookup((yyvsp[0].text), LOCD("variable", (yyloc)));
              free((yyvsp[0].text));
            }
#line 2002 "objects/parser.cxx"
    break;

  case 82: /* primary: '(' expr ')'  */
#line 508 "src/parser.y"
            {
              (yyval.expr) = (yyvsp[-1].expr);
            }
#line 2010 "objects/parser.cxx"
    break;

  case 83: /* primary: '[' expr ':' expr ']'  */
#line 512 "src/parser.y"
            {
              (yyval.expr) = new Range((yyvsp[-3].expr), (yyvsp[-1].expr), LOCD("range", (yyloc)));
            }
#line 2018 "objects/parser.cxx"
    break;

  case 84: /* primary: '[' expr ':' expr ':' expr ']'  */
#line 516 "src/parser.y"
            {
              (yyval.expr) = new Range((yyvsp[-5].expr), (yyvsp[-3].expr), (yyvsp[-1].expr), LOCD("range", (yyloc)));
            }
#line 2026 "objects/parser.cxx"
    break;

  case 85: /* primary: '[' optional_commas ']'  */
#line 520 "src/parser.y"
            {
              (yyval.expr) = new Literal(VectorType::Empty(), LOCD("vector", (yyloc)));
            }
#line 2034 "objects/parser.cxx"
    break;

  case 86: /* primary: '[' vector_expr optional_commas ']'  */
#line 524 "src/parser.y"
            {
              (yyval.expr) = (yyvsp[-2].vec);
            }
#line 2042 "objects/parser.cxx"
    break;

  case 87: /* expr_or_empty: %empty  */
#line 531 "src/parser.y"
            {
              (yyval.expr) = NULL;
            }
#line 2050 "objects/parser.cxx"
    break;

  case 88: /* expr_or_empty: expr  */
#line 535 "src/parser.y"
            {
              (yyval.expr) = (yyvsp[0].expr);
            }
#line 2058 "objects/parser.cxx"
    break;

  case 89: /* list_comprehension_elements: TOK_LET '(' arguments_call ')' list_comprehension_elements_p  */
#line 544 "src/parser.y"
            {
              (yyval.expr) = new LcLet(*(yyvsp[-2].args), (yyvsp[0].expr), LOCD("lclet", (yyloc)));
              delete (yyvsp[-2].args);
            }
#line 2067 "objects/parser.cxx"
    break;

  case 90: /* list_comprehension_elements: TOK_EACH list_comprehension_elements_or_expr  */
#line 549 "src/parser.y"
            {
              (yyval.expr) = new LcEach((yyvsp[0].expr), LOCD("lceach", (yyloc)));
            }
#line 2075 "objects/parser.cxx"
    break;

  case 91: /* list_comprehension_elements: TOK_FOR '(' arguments_call ')' list_comprehension_elements_or_expr  */
#line 553 "src/parser.y"
            {
                (yyval.expr) = (yyvsp[0].expr);

                /* transform for(i=...,j=...) -> for(i=...) for(j=...) */
                for (int i = (yyvsp[-2].args)->size()-1; i >= 0; i--) {
                  AssignmentList arglist;
                  arglist.push_back((*(yyvsp[-2].args))[i]);
                  Expression *e = new LcFor(arglist, (yyval.expr), LOCD("lcfor", (yyloc)));
                    (yyval.expr) = e;
                }
                delete (yyvsp[-2].args);
            }
#line 2092 "objects/parser.cxx"
    break;

  case 92: /* list_comprehension_elements: TOK_FOR '(' arguments_call ';' expr ';' arguments_call ')' list_comprehension_elements_or_expr  */
#line 566 "src/parser.y"
            {
              (yyval.expr) = new LcForC(*(yyvsp[-6].args), *(yyvsp[-2].args), (yyvsp[-4].expr), (yyvsp[0].expr), LOCD("lcforc", (yyloc)));
                delete (yyvsp[-6].args);
                delete (yyvsp[-2].args);
            }
#line 2102 "objects/parser.cxx"
    break;

  case 93: /* list_comprehension_elements: TOK_IF '(' expr ')' list_comprehension_elements_or_expr  */
#line 572 "src/parser.y"
            {
              (yyval.expr) = new LcIf((yyvsp[-2].expr), (yyvsp[0].expr), 0, LOCD("lcif", (yyloc)));
            }
#line 2110 "objects/parser.cxx"
    break;

  case 94: /* list_comprehension_elements: TOK_IF '(' expr ')' list_comprehension_elements_or_expr TOK_ELSE list_comprehension_elements_or_expr  */
#line 576 "src/parser.y"
            {
              (yyval.expr) = new LcIf((yyvsp[-4].expr), (yyvsp[-2].expr), (yyvsp[0].expr), LOCD("lcifelse", (yyloc)));
            }
#line 2118 "objects/parser.cxx"
    break;

  case 96: /* list_comprehension_elements_p: '(' list_comprehension_elements ')'  */
#line 585 "src/parser.y"
            {
                (yyval.expr) = (yyvsp[-1].expr);
            }
#line 2126 "objects/parser.cxx"
    break;

  case 101: /* vector_expr: expr  */
#line 602 "src/parser.y"
            {
              (yyval.vec) = new Vector(LOCD("vector", (yyloc)));
              (yyval.vec)->emplace_back((yyvsp[0].expr));
            }
#line 2135 "objects/parser.cxx"
    break;

  case 102: /* vector_expr: list_comprehension_elements  */
#line 607 "src/parser.y"
            {
              (yyval.vec) = new Vector(LOCD("vector", (yyloc)));
              (yyval.vec)->emplace_back((yyvsp[0].expr));
            }
#line 2144 "objects/parser.cxx"
    break;

  case 103: /* vector_expr: vector_expr ',' optional_commas list_comprehension_elements_or_expr  */
#line 612 "src/parser.y"
            {
              (yyval.vec) = (yyvsp[-3].vec);
              (yyval.vec)->emplace_back((yyvsp[0].expr));
            }
#line 2153 "objects/parser.cxx"
    break;

  case 104: /* arguments_decl: %empty  */
#line 620 "src/parser.y"
            {
                (yyval.args) = new AssignmentList();
            }
#line 2161 "objects/parser.cxx"
    break;

  case 105: /* arguments_decl: argument_decl  */
#line 624 "src/parser.y"
            {
                (yyval.args) = new AssignmentList();
                (yyval.args)->emplace_back((yyvsp[0].arg));
            }
#line 2170 "objects/parser.cxx"
    break;

  case 106: /* arguments_decl: arguments_decl ',' optional_commas argument_decl  */
#line 629 "src/parser.y"
            {
                (yyval.args) = (yyvsp[-3].args);
                (yyval.args)->emplace_back((yyvsp[0].arg));
            }
#line 2179 "objects/parser.cxx"
    break;

  case 107: /* argument_decl: TOK_ID  */
#line 637 "src/parser.y"
            {
                (yyval.arg) = new Assignment((yyvsp[0].text), LOCD("assignment", (yyloc)));
                free((yyvsp[0].text));
            }
#line 2188 "objects/parser.cxx"
    break;

  case 108: /* argument_decl: TOK_ID '=' expr  */
#line 642 "src/parser.y"
            {
              (yyval.arg) = new Assignment((yyvsp[-2].text), shared_ptr<Expression>((yyvsp[0].expr)), LOCD("assignment", (yyloc)));
                free((yyvsp[-2].text));
            }
#line 2197 "objects/parser.cxx"
    break;

  case 109: /* arguments_call: %empty  */
#line 650 "src/parser.y"
            {
                (yyval.args) = new AssignmentList();
            }
#line 2205 "objects/parser.cxx"
    break;

  case 110: /* arguments_call: argument_call  */
#line 654 "src/parser.y"
            {
                (yyval.args) = new AssignmentList();
                (yyval.args)->emplace_back((yyvsp[0].arg));
            }
#line 2214 "objects/parser.cxx"
    break;

  case 111: /* arguments_call: arguments_call ',' optional_commas argument_call  */
#line 659 "src/parser.y"
            {
                (yyval.args) = (yyvsp[-3].args);
                (yyval.args)->emplace_back((yyvsp[0].arg));
            }
#line 2223 "objects/parser.cxx"
    break;

  case 112: /* argument_call: expr  */
#line 667 "src/parser.y"
            {
                (yyval.arg) = new Assignment("", shared_ptr<Expression>((yyvsp[0].expr)), LOCD("argumentcall", (yyloc)));
            }
#line 2231 "objects/parser.cxx"
    break;

  case 113: /* argument_call: TOK_ID '=' expr  */
#line 671 "src/parser.y"
            {
                (yyval.arg) = new Assignment((yyvsp[-2].text), shared_ptr<Expression>((yyvsp[0].expr)), LOCD("argumentcall", (yyloc)));
                free((yyvsp[-2].text));
            }
#line 2240 "objects/parser.cxx"
    break;


#line 2244 "objects/parser.cxx"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 677 "src/parser.y"


int parserlex(void)
{
  return lexerlex();
}

void yyerror (char const *s)
{
  // FIXME: We leak memory on parser errors...
	Location loc = Location(lexerget_lineno(), -1, -1, -1, sourcefile());
	LOG(message_group::Error, loc, "", "Parser error: %1$s", s);
}

#ifdef DEBUG
static Location debug_location(const std::string& info, const YYLTYPE& loc)
{
	auto location = LOC(loc);
	PRINTDB("%3d, %3d - %3d, %3d | %s", loc.first_line % loc.first_column % loc.last_line % loc.last_column % info);
	return location;
}
#endif

static void warn_reassignment(const Location& loc, const shared_ptr<Assignment>& assignment, const fs::path& path)
{
	LOG(message_group::Warning,
			loc,
			path.parent_path().generic_string(),
			"%1$s was assigned on line %2$i but was overwritten",
			assignment->getName(),
			assignment->location().firstLine());

}

static void warn_reassignment(const Location& loc, const shared_ptr<Assignment>& assignment, const fs::path& path1, const fs::path& path2)
{
	LOG(message_group::Warning,
			loc,
			path1.parent_path().generic_string(),
			"%1$s was assigned on line %2$i of %3$s but was overwritten",
			assignment->getName(),
			assignment->location().firstLine(),
			path2);
}

void handle_assignment(const std::string token, Expression *expr, const Location loc)
{
	bool found = false;
	for (auto &assignment : scope_stack.top()->assignments) {
		if (assignment->getName() == token) {
			auto mainFile = mainFilePath.string();
			auto prevFile = assignment->location().fileName();
			auto currFile = loc.fileName();

			const auto uncPathCurr = boostfs_uncomplete(currFile, mainFilePath.parent_path());
			const auto uncPathPrev = boostfs_uncomplete(prevFile, mainFilePath.parent_path());
			if (fileEnded) {
				//assignments via commandline
			} else if (prevFile == mainFile && currFile == mainFile) {
				//both assignments in the mainFile
				warn_reassignment(loc, assignment, mainFilePath);
			} else if (uncPathCurr == uncPathPrev) {
				//assignment overwritten within the same file
				//the line number being equal happens, when a file is included multiple times
				if (assignment->location().firstLine() != loc.firstLine()) {
					warn_reassignment(loc, assignment, mainFilePath, uncPathPrev);
				}
			} else if (prevFile == mainFile && currFile != mainFile) {
				//assignment from the mainFile overwritten by an include
				warn_reassignment(loc, assignment, mainFilePath, uncPathPrev);
			}
			assignment->setExpr(shared_ptr<Expression>(expr));
			assignment->setLocation(loc);
			found = true;
			break;
		}
	}
	if (!found) {
		scope_stack.top()->addChild(assignment(token, shared_ptr<Expression>(expr), loc));
	}
}

bool parse(FileModule *&module, const std::string& text, const std::string &filename, const std::string &mainFile, int debug)
{
  fs::path filepath = fs::absolute(fs::path(filename));
  mainFilePath = fs::absolute(fs::path(mainFile));
  parsingMainFile = mainFilePath == filepath;

  fs::path parser_sourcefile = fs::path(filepath).generic_string();
  sourcefile_folder = parser_sourcefile.parent_path().string();
  lexer_set_parser_sourcefile(parser_sourcefile);

  lexerin = NULL;
  parser_error_pos = -1;
  parser_input_buffer = text.c_str();
  fileEnded = false;

  rootmodule = new FileModule(sourcefile_folder, parser_sourcefile.filename().string());
  scope_stack.push(&rootmodule->scope);
  //        PRINTB_NOCACHE("New module: %s %p", "root" % rootmodule);

  parserdebug = debug;
  int parserretval = -1;
  try{
     parserretval = parserparse();
  }catch (const HardWarningException &e) {
    yyerror("stop on first warning");
  }

  lexerdestroy();
  lexerlex_destroy();

  module = rootmodule;
  if (parserretval != 0) return false;

  parser_error_pos = -1;
  parser_input_buffer = nullptr;
  scope_stack.pop();

  return true;
}
